﻿using C1.WPF.Grid;
using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.ComponentModel;
using System.Globalization;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace GridDemo
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        ObservableCollection<Product> Products;
        public MainWindow()
        {
            InitializeComponent();
            Products = new ObservableCollection<Product>();
            for(int i=0;i<100;i++)
            {
                Products.Add(new Product() { Id = i, Name = "Product " + i, Dispatch = DateTime.Today.AddDays(i) });
            }
            grid.ItemsSource = Products;
            grid.CellFactory = new CustomCellFactory();
        }
    }

    public class CustomCellFactory : GridCellFactory
    {
        public override void BindCellContent(GridCellType cellType, GridCellRange range, FrameworkElement cellContent)
        {
            base.BindCellContent(cellType, range, cellContent);
            if (Grid.Columns[range.Column].ColumnName == "Dispatch" && cellType == GridCellType.Cell)
            {
                if (cellContent is TextBlock tb)
                {
                    tb.Text = (DateTime.Parse(tb.Text)).ToString(CultureInfo.CurrentCulture.DateTimeFormat.ShortDatePattern, CultureInfo.CurrentCulture);
                }
            }
        }
    }

    public class Product
    {
        public int Id { get; set; }
        public string Name { get; set; }
        public DateTime? Dispatch { get; set; }
    }
}
